=== debian/changelog ===
fastnetmon (1.1.3+dfsg-6build1) bionic; urgency=medium

  * No-change rebuild.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 10 Apr 2018 16:44:39 +0200

fastnetmon (1.1.3+dfsg-6) unstable; urgency=medium

  * Include patches to add support for Memory Model Aware Atomic Operations
    and adapt link-agains-atomic patch to __atomic_add_fetch (Closes: #869805)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Tue, 06 Feb 2018 00:18:14 +0100

fastnetmon (1.1.3+dfsg-5) unstable; urgency=medium

  * Support nDPI 2.2 (Closes: #887623)
  * Move packaging repository to salsa.debian.org
  * Bump Standards-Version to 4.1.3 (no changes needed)
  * Switch to debhelper 11
  * Disable luajit support also on ia64, powerpc, and powerpcspe
  * Link against atomic if __sync_fetch_and_add is missing (Closes: #869805)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Tue, 30 Jan 2018 12:29:33 +0100

fastnetmon (1.1.3+dfsg-4) unstable; urgency=medium

  * Use pkg-config for finding luajit (Closes: #873325)
  * Enable luajit support on arm64, kfreebsd-amd64, mips64el, ppc64*

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 11 Sep 2017 14:27:56 +0200

fastnetmon (1.1.3+dfsg-3) unstable; urgency=medium

  * Disable Lua support for architectures where Lua is missing
  * Disable netmap support on hurd-i386 (Closes: #869622)
  * Bump Standards-Version to 4.1.0 (no changes needed)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Thu, 24 Aug 2017 17:02:57 +0200

fastnetmon (1.1.3+dfsg-2) unstable; urgency=medium

  * Removed code which uses x86_only features (Closes: #869621)
  * GoBGP project re-licensed gobgp_api_client.proto from Apache to MIT/Expat

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Wed, 26 Jul 2017 12:33:03 +0200

fastnetmon (1.1.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #862104)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 24 Jul 2017 11:55:54 +0200
