=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Disable Lua support for all architectures where libluajit-5.1-dev is not available
ifeq (,$(filter-out alpha hppa ia64 m68k powerpc powerpcspe s390x sh4 sparc64 x32,$(DEB_HOST_ARCH)))
EXTRA_ARGS = -DENABLE_LUA_SUPPORT=OFF
endif

# Disable netmap support on hurd-i386 (Closes: #869622)
ifeq (,$(filter-out hurd-i386,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DDISABLE_NETMAP_SUPPORT=ON
endif

ifeq (,$(filter-out mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DUSE_NEW_ATOMIC_BUILTINS=ON
endif

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- -DDISABLE_PF_RING_SUPPORT=yes $(EXTRA_ARGS)

override_dh_installinit:
	dh_installinit --only-scripts
