## fastnetmon 1.1.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,11 +21,17 @@
 # Get convinient paths for all system folders: http://www.cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a262fe09
 # include(GNUInstallDirs)
 
+include(CheckCXXCompilerFlag)
+include(CheckLibraryExists)
+
 # Enable it and fix all warnigns!
 # add_definitions ("-Wall")
 
 set (FASTNETMON_VERSION_MAJOR 1)
 set (FASTNETMON_VERSION_MINOR 1)
+
+set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "/lib/systemd/system"
+  CACHE PATH "Location for systemd service files")
 
 if (ENABLE_GOBGP_SUPPORT)
     # We could not compile gRPC without C++ 11
@@ -81,6 +87,8 @@
     set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${FASTNETMON_PROFILE_FLAGS}")
 endif()
 
+execute_process(COMMAND sh -c ". /etc/os-release; echo $ID" OUTPUT_VARIABLE OS_ID ERROR_QUIET)
+
 ### Executables definition 
 
 # Main tool
@@ -92,7 +100,30 @@
 set(FASTNETMON_APPLICATION_VERSION "1.1.3 master git-${GIT_LAST_COMMIT_HASH}")
 configure_file(fast_platform.h.template "${PROJECT_SOURCE_DIR}/fast_platform.h")
 
-# With this flag we can diable PF_RING build via console: cmake .. -DDISABLE_PF_RING_SUPPORT=ON
+# Use new Memory Model Aware Atomic Operations
+# You could enable it using: cmake .. -DUSE_NEW_ATOMIC_BUILTINS=ON
+if (USE_NEW_ATOMIC_BUILTINS)
+    message(STATUS "Will use new memory model aware atomic builtins")
+    add_definitions(-DUSE_NEW_ATOMIC_BUILTINS) 
+endif() 
+
+CHECK_CXX_SOURCE_COMPILES("
+#include <cstdint>
+int main() {
+    uint64_t x = 1;
+    __atomic_add_fetch(&x, 0, __ATOMIC_RELAXED);
+    return x;
+}
+" HAVE__ATOMIC_ADD_FETCH)
+
+if (NOT HAVE__ATOMIC_ADD_FETCH)
+    check_library_exists(atomic __atomic_add_fetch_8 "" HAVE_LIBATOMIC)
+    if (HAVE_LIBATOMIC)
+        target_link_libraries(fastnetmon atomic)
+    endif()
+endif()
+
+# With this flag we can disable PF_RING build via console: cmake .. -DDISABLE_PF_RING_SUPPORT=ON
 if (NOT DISABLE_PF_RING_SUPPORT) 
     if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
         message(STATUS "You are running Linux and we can build PF_RING support")
@@ -102,6 +133,13 @@
     endif() 
 endif()
 
+option(ENABLE_NETMAP_SUPPORT "Enable Netmap support" ON)
+
+if (ENABLE_NETMAP_SUPPORT)
+    message(STATUS "We will build Netmap support for you")
+    add_definitions(-DNETMAP_PLUGIN)
+endif()
+
 if (ENABLE_PFRING_SUPPORT)
     # Set path to manually compiled PF_RING
     set(PFRING_INCLUDE_DIRS "${PFRING_CUSTOM_INSTALL_PATH}/include")
@@ -135,6 +173,10 @@
 
 # Our tools library
 add_library(fast_library STATIC fast_library.cpp)
+
+# Our parser
+add_library(unified_parser STATIC unified_parser.cpp)
+target_link_libraries(unified_parser fastnetmon_packet_parser)
 
 # Our ipfix database library
 add_library(ipfix_rfc STATIC ipfix_rfc.cpp)
@@ -175,6 +217,7 @@
 if (ENABLE_AFPACKET_SUPPORT)
    add_definitions(-DFASTNETMON_ENABLE_AFPACKET) 
    add_library(afpacket_plugin STATIC afpacket_plugin/afpacket_collector.cpp)
+   target_link_libraries(afpacket_plugin unified_parser)
 endif()
 
 # sFLOW plugin
@@ -184,7 +227,7 @@
 add_library(netflow_plugin STATIC netflow_plugin/netflow_collector.cpp)
 target_link_libraries(netflow_plugin ipfix_rfc)
 
-set(ENABLE_DPI_SUPPORT YES)
+option(ENABLE_DPI_SUPPORT "Enable Deep Packet Inspection support" ON)
 if (ENABLE_DPI_SUPPORT) 
     message(STATUS "We will enable nDPI support")
 
@@ -209,7 +252,7 @@
 # We do not enable it by default, it's testing feature
 # If you want it please build with:
 # cmake -DENABLE_LUA_SUPPORT=ON .. 
-set(ENABLE_LUA_SUPPORT yes)
+option(ENABLE_LUA_SUPPORT "Enable Lua support" ON)
 if (ENABLE_LUA_SUPPORT)
     message(STATUS "We will enable LuaJIT support")
 
@@ -275,30 +318,3 @@
     find_library(GRPC_LIBRARY_GPR_PATH NAMES gpr PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH)
     find_library(GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH NAMES grpc++_unsecure PATHS "${GRPC_CUSTOM_INSTALL_PATH}/lib" NO_DEFAULT_PATH) 
 
-    if (GRPC_INCLUDES_FOLDER AND GRPC_LIBRARY_GRPC_PATH AND GRPC_LIBRARY_GPR_PATH AND GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH)
-        include_directories(${GRPC_INCLUDES_FOLDER})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_PATH})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GPR_PATH})
-        target_link_libraries(gobgp_action ${GRPC_LIBRARY_GRPC_CPP_UNSECURE_PATH})
-    else()
-        message(FATAL_ERROR "Could not find gRPC library")
-    endif()
-
-    find_path(PROTOCOL_BUFFERS_INCLUDE_FOLDER NAMES "google/protobuf/stubs/common.h" PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/include")
-
-    find_library(PROTOCOL_BUFFERS_LIBRARY_PATH NAMES protobuf PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/lib") 
-
-    if (PROTOCOL_BUFFERS_INCLUDE_FOLDER AND PROTOCOL_BUFFERS_LIBRARY_PATH)
-        include_directories(${PROTOCOL_BUFFERS_INCLUDE_FOLDER}) 
-        target_link_libraries(gobgp_action ${PROTOCOL_BUFFERS_LIBRARY_PATH}) 
-    else()
-        message(FATAL_ERROR "Could not find protocol buffers")
-    endif()
-
-
-    # message(STATUS "grpc: ${GRPC_INCLUDES_FOLDER} ${GRPC_LIBRARY_GRPC_PATH} ${GRPC_LIBRARY_GPR_PATH}")
-    # message(STATUS ${PROJECT_BINARY_DIR})
-
-    find_program(PROTOC_BINARY protoc PATHS "${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}/bin" NO_DEFAULT_PATH)
-
-    if (PROTOC_BINARY)
