=== debian/changelog ===
fastnetmon (1.1.4-1build5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:51:22 +0100

fastnetmon (1.1.4-1build4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:20:44 +0100

fastnetmon (1.1.4-1build3) focal; urgency=medium

  * No-change rebuild against libndpi2.6, because ndpi 3.0-1 is broken

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 23 Feb 2020 12:46:19 -0800

fastnetmon (1.1.4-1build2) focal; urgency=medium

  * No-change rebuild against libboost-regex1.67.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 18:55:26 +0000

fastnetmon (1.1.4-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:21:50 +0000

fastnetmon (1.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop 18 patches that are included upstream and refresh remaining patches

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Mon, 08 Jul 2019 16:16:29 +0200

fastnetmon (1.1.3+dfsg-8) unstable; urgency=medium

  * Add patch for changed include path in nDPI 2.6 (Closes: #919861)
  * Disable Lua support on riscv64 (libluajit-5.1-dev needed there)
  * Bump Standards-Version to 4.3.0 (no changes needed)

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Mon, 21 Jan 2019 14:38:46 +0100

fastnetmon (1.1.3+dfsg-7) unstable; urgency=medium

  [ Jesse Norell ]
  * Fixed insecure permissions for fastnetmon.dat

  [ Benjamin Drung ]
  * Update my email address to @cloud.ionos.com
  * Bump Standards-Version to 4.2.1 (no changes needed)

 -- Benjamin Drung <benjamin.drung@cloud.ionos.com>  Fri, 21 Dec 2018 11:44:23 +0100
