=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: fastnetmon
-Maintainer: Benjamin Drung <benjamin.drung@profitbricks.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Benjamin Drung <benjamin.drung@cloud.ionos.com>
 Uploaders: Patrick Matthäi <pmatthaei@debian.org>
 Section: net
 Priority: optional
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Build-Depends: cmake,
                debhelper (>= 11),
                libboost-atomic-dev,
@@ -17,7 +18,7 @@
                libhiredis-dev,
                libjson-c-dev,
                liblog4cpp5-dev,
-               libluajit-5.1-dev [!alpha !hppa !ia64 !m68k !powerpc !powerpcspe !s390x !sh4 !sparc64 !x32],
+               libluajit-5.1-dev [!alpha !hppa !ia64 !m68k !powerpc !powerpcspe !riscv64 !s390x !sh4 !sparc64 !x32],
                libmongoc-dev,
                libncurses5-dev,
                libndpi-dev,
