=== debian/changelog ===
fastnetmon (1.2.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 28 Jun 2022 11:44:16 +0200

fastnetmon (1.2.2-1) unstable; urgency=medium

  * New upstream release.
    - Lua support was removed.
  * Adjust lintian override.
  * Do not install old init.d scripts anymore.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 22 Jun 2022 15:51:23 +0200

fastnetmon (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.1.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 16 May 2022 14:08:09 +0200

fastnetmon (1.2.0+git20220506-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Another try to fix mipsel build.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 06 May 2022 08:51:00 +0200

fastnetmon (1.2.0+git20220505-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Another try to fix mipsel build.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 05 May 2022 09:37:44 +0200

fastnetmon (1.2.0+git20220504-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Adjust debian/copyright.
    - This release should fix a FTBFS on mipsel.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 04 May 2022 16:05:49 +0200

fastnetmon (1.2.0+git20220503-1) unstable; urgency=medium

  * New upstream release.
    - Add new build dependency libicu-dev, capnproto, protobuf-compiler-grpc
      and golang-github-osrg-gobgp-dev.
    - Netmap and ndpi support has been removed.
      Closes: #981774
    - Removed all previous patches. The build system has been reworked by
      upstream, thanks for it!
    - Use new DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD build switch.
  * Bump Standards-Version to 4.6.0.
  * Set Rules-Requires-Root to no.
  * Remove old dependency on lsb-base.
  * Upgrade packaging to debhelper compat level 13.
  * Set myself as maintainer and remove Benjaming Drung. Thanks for your great
    work!
  * Set debian/watch version to 4.
  * Update debian/copyright.
  * Adjust some lintian overrides.
  * Add missing misc:Pre-Depends dependency.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 03 May 2022 09:34:44 +0200
