=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg// \
https://github.com/pavel-odintsov/fastnetmon/releases .*/v(\d\S+)\.tar\.gz
